Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1483)
+++ palm/trunk/SOURCE/Makefile	(revision 1484)
@@ -20,5 +20,6 @@
 # Current revisions:
 # ------------------
-# 
+# plant_canopy_model-dependency added for check_parameters, header, init_3d_model,
+# package_parin, read_var_list, user_init_plant_canopy, write_var_list
 # 
 # Former revisions:
@@ -288,5 +289,5 @@
 check_for_restart.o: modules.o mod_kinds.o
 check_open.o: modules.o mod_kinds.o mod_particle_attributes.o
-check_parameters.o: modules.o mod_kinds.o subsidence.o
+check_parameters.o: modules.o mod_kinds.o subsidence.o plant_canopy_model.o
 close_file.o: modules.o mod_kinds.o
 compute_vpt.o: modules.o mod_kinds.o
@@ -318,10 +319,10 @@
 flow_statistics.o: modules.o cpulog.o mod_kinds.o
 global_min_max.o: modules.o mod_kinds.o
-header.o: modules.o cpulog.o mod_kinds.o subsidence.o
+header.o: modules.o cpulog.o mod_kinds.o plant_canopy_model.o subsidence.o
 impact_of_latent_heat.o: modules.o mod_kinds.o
 inflow_turbulence.o: modules.o cpulog.o mod_kinds.o
 init_1d_model.o: modules.o mod_kinds.o
 init_3d_model.o: modules.o cpulog.o mod_kinds.o random_function.o advec_ws.o \
-	ls_forcing.o lpm_init.o random_generator_parallel.o
+	ls_forcing.o lpm_init.o plant_canopy_model.o random_generator_parallel.o
 init_advec.o: modules.o mod_kinds.o
 init_cloud_physics.o: modules.o mod_kinds.o
@@ -379,5 +380,5 @@
 netcdf.o: modules.o mod_kinds.o
 nudging.o: modules.o cpulog.o mod_kinds.o
-package_parin.o: modules.o mod_kinds.o
+package_parin.o: modules.o mod_kinds.o plant_canopy_model.o
 palm.o: modules.o cpulog.o ls_forcing.o mod_kinds.o nudging.o
 parin.o: modules.o cpulog.o mod_kinds.o progress_bar.o
@@ -400,5 +401,5 @@
 random_generator_parallel.o: mod_kinds.o
 read_3d_binary.o: modules.o cpulog.o mod_kinds.o random_function.o random_generator_parallel.o
-read_var_list.o: modules.o mod_kinds.o
+read_var_list.o: modules.o mod_kinds.o plant_canopy_model.o
 run_control.o: modules.o cpulog.o mod_kinds.o
 set_slicer_attributes_dvrp.o: modules.o mod_kinds.o
@@ -434,5 +435,5 @@
 user_init_3d_model.o: modules.o mod_kinds.o user_module.o
 user_init_grid.o: modules.o mod_kinds.o user_module.o
-user_init_plant_canopy.o: modules.o mod_kinds.o user_module.o
+user_init_plant_canopy.o: modules.o mod_kinds.o user_module.o plant_canopy_model.o
 user_last_actions.o: modules.o mod_kinds.o user_module.o
 user_lpm_advec.o: modules.o mod_kinds.o user_module.o
@@ -446,3 +447,3 @@
 wall_fluxes.o: modules.o mod_kinds.o
 write_3d_binary.o: modules.o cpulog.o mod_kinds.o random_function.o random_generator_parallel.o
-write_var_list.o: modules.o mod_kinds.o
+write_var_list.o: modules.o mod_kinds.o plant_canopy_model.o
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 1483)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1484)
@@ -20,5 +20,12 @@
 ! Current revisions:
 ! -----------------
-! 
+! Changes due to new module structure of the plant canopy model:
+!   module plant_canopy_model_mod added,
+!   checks regarding usage of new method for leaf area density profile 
+!   construction added,
+!   lad-profile construction moved to new subroutine init_plant_canopy within 
+!   the module plant_canopy_model_mod,
+!   drag_coefficient renamed to canopy_drag_coeff.
+! Missing KIND-attribute for REAL constant added
 ! 
 ! Former revisions:
@@ -246,4 +253,5 @@
     USE particle_attributes
     USE pegrid
+    USE plant_canopy_model_mod
     USE profil_parameter
     USE spectrum
@@ -891,15 +899,44 @@
     ENDIF
 
-    IF ( plant_canopy .AND. ( drag_coefficient == 0.0_wp ) ) THEN
-       message_string = 'plant_canopy = .TRUE. requires a non-zero drag ' // &
-                        'coefficient & given value is drag_coefficient = 0.0'
-       CALL message( 'check_parameters', 'PA0041', 1, 2, 0, 6, 0 )
-    ENDIF 
-
-    IF ( plant_canopy  .AND.  cloud_physics  .AND.  icloud_scheme == 0 ) THEN
-       message_string = 'plant_canopy = .TRUE. requires cloud_scheme /=' //  &
-                        ' seifert_beheng'
-       CALL message( 'check_parameters', 'PA0360', 1, 2, 0, 6, 0 )
-    ENDIF 
+    IF ( plant_canopy )  THEN
+    
+       IF ( canopy_drag_coeff == 0.0_wp )  THEN
+          message_string = 'plant_canopy = .TRUE. requires a non-zero drag '// &
+                           'coefficient & given value is canopy_drag_coeff = 0.0'
+          CALL message( 'check_parameters', 'PA0041', 1, 2, 0, 6, 0 )
+       ENDIF
+    
+       IF ( ( alpha_lad /= 9999999.9_wp  .AND.  beta_lad == 9999999.9_wp )  .OR.&
+              beta_lad /= 9999999.9_wp   .AND.  alpha_lad == 9999999.9_wp )  THEN
+          message_string = 'using the beta function for the construction ' //  &
+                           'of the leaf area density profile requires '    //  &
+                           'both alpha_lad and beta_lad to be /= 9999999.9'
+          CALL message( 'check_parameters', 'PA0118', 1, 2, 0, 6, 0 )
+       ENDIF
+    
+       IF ( calc_beta_lad_profile  .AND.  lai_beta == 0.0_wp )  THEN
+          message_string = 'using the beta function for the construction ' //  &
+                           'of the leaf area density profile requires '    //  &
+                           'a non-zero lai_beta, but given value is '      //  &
+                           'lai_beta = 0.0'
+          CALL message( 'check_parameters', 'PA0119', 1, 2, 0, 6, 0 )
+       ENDIF
+
+       IF ( calc_beta_lad_profile  .AND.  lad_surface /= 0.0_wp )  THEN
+          message_string = 'simultaneous setting of alpha_lad /= 9999999.9' // &
+                           'and lad_surface /= 0.0 is not possible, '       // &
+                           'use either vertical gradients or the beta '     // &
+                           'function for the construction of the leaf area '// &
+                           'density profile'
+          CALL message( 'check_parameters', 'PA0120', 1, 2, 0, 6, 0 )
+       ENDIF 
+
+       IF ( cloud_physics  .AND.  icloud_scheme == 0 )  THEN
+          message_string = 'plant_canopy = .TRUE. requires cloud_scheme /=' // &
+                           ' seifert_beheng'
+          CALL message( 'check_parameters', 'PA0360', 1, 2, 0, 6, 0 )
+       ENDIF 
+
+    ENDIF
 
     IF ( .NOT. ( loop_optimization == 'cache'  .OR.                            &
@@ -924,5 +961,4 @@
        IF ( ocean )           sa_init = sa_surface
        IF ( passive_scalar )  q_init  = s_surface
-       IF ( plant_canopy )    lad = 0.0_wp
 
 !
@@ -1264,47 +1300,4 @@
        ENDIF
 
-!
-!--    If required compute the profile of leaf area density used in the plant
-!--    canopy model 
-       IF ( plant_canopy ) THEN
-       
-          i = 1
-          gradient = 0.0_wp
-
-          IF ( .NOT. ocean ) THEN
-
-             lad(0) = lad_surface
- 
-             lad_vertical_gradient_level_ind(1) = 0
-             DO k = 1, pch_index
-                IF ( i < 11 ) THEN
-                   IF ( lad_vertical_gradient_level(i) < zu(k) .AND.  &
-                        lad_vertical_gradient_level(i) >= 0.0_wp ) THEN
-                      gradient = lad_vertical_gradient(i)
-                      lad_vertical_gradient_level_ind(i) = k - 1
-                      i = i + 1
-                   ENDIF
-                ENDIF
-                IF ( gradient /= 0.0_wp ) THEN
-                   IF ( k /= 1 ) THEN
-                      lad(k) = lad(k-1) + dzu(k) * gradient
-                   ELSE
-                      lad(k) = lad_surface + dzu(k) *gradient
-                   ENDIF
-                ELSE
-                   lad(k) = lad(k-1)
-                ENDIF
-             ENDDO
-
-          ENDIF
-
-!
-!--       In case of no given leaf area density gradients, choose a vanishing
-!--       gradient
-          IF ( lad_vertical_gradient_level(1) == -9999999.9_wp ) THEN
-             lad_vertical_gradient_level(1) = 0.0_wp
-          ENDIF
-
-       ENDIF
          
     ENDIF
@@ -1631,5 +1624,5 @@
        ENDIF
 
-       IF ( top_heatflux /= 0.0  .AND.  top_heatflux /= 9999999.9_wp ) &
+       IF ( top_heatflux /= 0.0_wp  .AND.  top_heatflux /= 9999999.9_wp ) &
        THEN
           message_string = 'heatflux must not be set for pure neutral flow'
@@ -1828,5 +1821,5 @@
        rayleigh_damping_factor = 0.0_wp
     ELSE
-       IF ( rayleigh_damping_factor < 0.0 .OR. rayleigh_damping_factor > 1.0_wp ) &
+       IF ( rayleigh_damping_factor < 0.0_wp .OR. rayleigh_damping_factor > 1.0_wp ) &
        THEN
           WRITE( message_string, * )  'rayleigh_damping_factor = ', &
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 1483)
+++ palm/trunk/SOURCE/header.f90	(revision 1484)
@@ -20,5 +20,12 @@
 ! Current revisions:
 ! -----------------
-! 
+! Changes due to new module structure of the plant canopy model:
+!   module plant_canopy_model_mod and output for new canopy model parameters 
+!   (alpha_lad, beta_lad, lai_beta,...) added,
+!   drag_coefficient, leaf_surface_concentration and scalar_exchange_coefficient
+!   renamed to canopy_drag_coeff, leaf_surface_conc and leaf_scalar_exch_coeff,
+!   learde renamed leaf_area_density.
+! Bugfix: DO-WHILE-loop for lad header information additionally restricted 
+! by maximum number of gradient levels (currently 10)
 !
 ! Former revisions:
@@ -165,5 +172,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  lad, pt_init, qsws, q_init, sa_init, shf, ug, vg, w_subs, zu
+        ONLY:  pt_init, qsws, q_init, sa_init, shf, ug, vg, w_subs, zu
         
     USE control_parameters
@@ -205,4 +212,11 @@
         
     USE pegrid
+
+    USE plant_canopy_model_mod,                                                &
+        ONLY:  alpha_lad, beta_lad, calc_beta_lad_profile, canopy_drag_coeff,  &
+               canopy_mode, cthf, lad, lad_surface, lad_vertical_gradient,     &
+               lad_vertical_gradient_level, lad_vertical_gradient_level_ind,   &
+               lai_beta, leaf_scalar_exch_coeff, leaf_surface_conc, pch_index, &
+               plant_canopy
     
     USE spectrum,                                                              &
@@ -242,5 +256,5 @@
     CHARACTER (LEN=86) ::  coordinates         !:
     CHARACTER (LEN=86) ::  gradients           !:
-    CHARACTER (LEN=86) ::  learde              !:
+    CHARACTER (LEN=86) ::  leaf_area_density   !:
     CHARACTER (LEN=86) ::  slices              !:
     CHARACTER (LEN=86) ::  temperatures        !:
@@ -270,8 +284,10 @@
     INTEGER(iwp) ::  io        !:
     INTEGER(iwp) ::  j         !:
+    INTEGER(iwp) ::  k         !:
     INTEGER(iwp) ::  l         !:
     INTEGER(iwp) ::  ll        !:
     INTEGER(iwp) ::  mpi_type  !:
     
+    REAL(wp) ::  canopy_height                    !: canopy height (in m)
     REAL(wp) ::  cpuseconds_per_simulated_second  !:
 
@@ -760,44 +776,71 @@
 
     IF ( plant_canopy )  THEN
-
-       WRITE ( io, 280 ) canopy_mode, pch_index, drag_coefficient
+    
+       canopy_height = pch_index * dz
+
+       WRITE ( io, 280 )  canopy_mode, canopy_height, pch_index,               &
+                          canopy_drag_coeff
        IF ( passive_scalar )  THEN
-          WRITE ( io, 281 ) scalar_exchange_coefficient,   &
-                            leaf_surface_concentration
+          WRITE ( io, 281 )  leaf_scalar_exch_coeff,                           &
+                             leaf_surface_conc
        ENDIF
 
 !
 !--    Heat flux at the top of vegetation
-       WRITE ( io, 282 ) cthf
-
-!
-!--    Leaf area density profile
-!--    Building output strings, starting with surface value
-       WRITE ( learde, '(F6.4)' )  lad_surface
-       gradients = '------'
-       slices = '     0'
-       coordinates = '   0.0'
-       i = 1
-       DO  WHILE ( lad_vertical_gradient_level_ind(i) /= -9999 )
-
-          WRITE (coor_chr,'(F7.2)')  lad(lad_vertical_gradient_level_ind(i))
-          learde = TRIM( learde ) // ' ' // TRIM( coor_chr )
-
-          WRITE (coor_chr,'(F7.2)')  lad_vertical_gradient(i)
-          gradients = TRIM( gradients ) // ' ' // TRIM( coor_chr )
-
-          WRITE (coor_chr,'(I7)')  lad_vertical_gradient_level_ind(i)
-          slices = TRIM( slices ) // ' ' // TRIM( coor_chr )
-
-          WRITE (coor_chr,'(F7.1)')  lad_vertical_gradient_level(i)
-          coordinates = TRIM( coordinates ) // ' '  // TRIM( coor_chr )
-
-          i = i + 1
-       ENDDO
-
-       WRITE ( io, 283 )  TRIM( coordinates ), TRIM( learde ), &
-                          TRIM( gradients ), TRIM( slices )
-
-    ENDIF
+       WRITE ( io, 282 )  cthf
+
+!
+!--    Leaf area density profile, calculated either from given vertical 
+!--    gradients or from beta probability density function.
+       IF (  .NOT.  calc_beta_lad_profile )  THEN
+
+!--       Building output strings, starting with surface value
+          WRITE ( leaf_area_density, '(F6.4)' )  lad_surface
+          gradients = '------'
+          slices = '     0'
+          coordinates = '   0.0'
+          i = 1
+          DO  WHILE ( i < 11  .AND.  lad_vertical_gradient_level_ind(i) /= -9999 )
+
+             WRITE (coor_chr,'(F7.2)')  lad(lad_vertical_gradient_level_ind(i))
+             leaf_area_density = TRIM( leaf_area_density ) // ' ' // TRIM( coor_chr )
+ 
+             WRITE (coor_chr,'(F7.2)')  lad_vertical_gradient(i)
+             gradients = TRIM( gradients ) // ' ' // TRIM( coor_chr )
+
+             WRITE (coor_chr,'(I7)')  lad_vertical_gradient_level_ind(i)
+             slices = TRIM( slices ) // ' ' // TRIM( coor_chr )
+
+             WRITE (coor_chr,'(F7.1)')  lad_vertical_gradient_level(i)
+             coordinates = TRIM( coordinates ) // ' '  // TRIM( coor_chr )
+
+             i = i + 1
+          ENDDO
+
+          WRITE ( io, 283 )  TRIM( coordinates ), TRIM( leaf_area_density ),              &
+                             TRIM( gradients ), TRIM( slices )
+
+       ELSE
+       
+          WRITE ( leaf_area_density, '(F6.4)' )  lad_surface
+          coordinates = '   0.0'
+          
+          DO  k = 1, pch_index
+
+             WRITE (coor_chr,'(F7.2)')  lad(k)
+             leaf_area_density = TRIM( leaf_area_density ) // ' ' // TRIM( coor_chr )
+ 
+             WRITE (coor_chr,'(F7.1)')  zu(k)
+             coordinates = TRIM( coordinates ) // ' '  // TRIM( coor_chr )
+
+          ENDDO       
+
+          WRITE ( io, 284 ) TRIM( coordinates ), TRIM( leaf_area_density ), alpha_lad,    &
+                            beta_lad, lai_beta
+
+       ENDIF  
+
+    ENDIF
+
 
 !
@@ -1836,7 +1879,7 @@
               ' ------------------------------'// &
               ' Canopy mode: ', A / &
-              ' Canopy top: ',I4 / &
+              ' Canopy height: ',F6.2,'m (',I4,' grid points)' / &
               ' Leaf drag coefficient: ',F6.2 /)
-281 FORMAT (/ ' Scalar_exchange_coefficient: ',F6.2 / &
+281 FORMAT (/ ' Scalar exchange coefficient: ',F6.2 / &
               ' Scalar concentration at leaf surfaces in kg/m**3: ',F6.2 /)
 282 FORMAT (' Predefined constant heatflux at the top of the vegetation: ',F6.2,' K m/s')
@@ -1846,4 +1889,10 @@
               ' Gradient:            ',A,'  m**2/m**4'/ &
               ' Gridpoint:           ',A)
+284 FORMAT (//' Characteristic levels of the leaf area density and coefficients:'// &
+              ' Height:              ',A,'  m'/ &
+              ' Leaf area density:   ',A,'  m**2/m**3'/ &
+              ' Coefficient alpha: ',F6.2 / &
+              ' Coefficient beta: ',F6.2 / &
+              ' Leaf area index: ',F6.2,'  m**2/m**2' /)
                
 300 FORMAT (//' Boundary conditions:'/ &
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 1483)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1484)
@@ -20,5 +20,8 @@
 ! Current revisions:
 ! ------------------
-! 
+! Changes due to new module structure of the plant canopy model:
+!   canopy-related initialization (e.g. lad and canopy_heat_flux) moved to new 
+!   subroutine init_plant_canopy within the module plant_canopy_model_mod,
+!   call of subroutine init_plant_canopy added.
 ! 
 ! Former revisions:
@@ -217,4 +220,7 @@
     USE pegrid
     
+    USE plant_canopy_model_mod,                                                &
+        ONLY:  init_plant_canopy, plant_canopy
+    
     USE random_function_mod 
     
@@ -517,25 +523,4 @@
     
 !
-!-- 3D-arrays for the leaf area density and the canopy drag coefficient
-    IF ( plant_canopy ) THEN
-       ALLOCATE ( lad_s(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
-                  lad_u(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
-                  lad_v(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
-                  lad_w(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
-                  cdc(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-
-       IF ( passive_scalar ) THEN
-          ALLOCATE ( sls(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
-                     sec(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ) 
-       ENDIF
-
-       IF ( cthf /= 0.0_wp ) THEN
-          ALLOCATE ( lai(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
-                     canopy_heat_flux(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-       ENDIF
-
-    ENDIF
-
-!
 !-- 4D-array for storing the Rif-values at vertical walls
     IF ( topography /= 'flat' )  THEN
@@ -1571,113 +1556,6 @@
 
 !
-!-- Initialization of the leaf area density
-    IF ( plant_canopy )  THEN
- 
-       SELECT CASE ( TRIM( canopy_mode ) )
-
-          CASE( 'block' )
-
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   lad_s(:,j,i) = lad(:)
-                   cdc(:,j,i)   = drag_coefficient
-                   IF ( passive_scalar )  THEN
-                      sls(:,j,i) = leaf_surface_concentration
-                      sec(:,j,i) = scalar_exchange_coefficient
-                   ENDIF
-                ENDDO
-             ENDDO
-
-          CASE DEFAULT
-
-!
-!--          The DEFAULT case is reached either if the parameter 
-!--          canopy mode contains a wrong character string or if the 
-!--          user has coded a special case in the user interface. 
-!--          There, the subroutine user_init_plant_canopy checks 
-!--          which of these two conditions applies.
-             CALL user_init_plant_canopy
- 
-          END SELECT
-
-       CALL exchange_horiz( lad_s, nbgp )
-       CALL exchange_horiz( cdc, nbgp )
-
-       IF ( passive_scalar )  THEN
-          CALL exchange_horiz( sls, nbgp )
-          CALL exchange_horiz( sec, nbgp )
-       ENDIF
-
-!
-!--    Sharp boundaries of the plant canopy in horizontal directions
-!--    In vertical direction the interpolation is retained, as the leaf
-!--    area density is initialised by prescribing a vertical profile 
-!--    consisting of piecewise linear segments. The upper boundary 
-!--    of the plant canopy is now defined by lad_w(pch_index,:,:) = 0.0.
-
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb, nzt+1 
-                IF ( lad_s(k,j,i) > 0.0_wp )  THEN
-                   lad_u(k,j,i)   = lad_s(k,j,i) 
-                   lad_u(k,j,i+1) = lad_s(k,j,i)
-                   lad_v(k,j,i)   = lad_s(k,j,i)
-                   lad_v(k,j+1,i) = lad_s(k,j,i)
-                ENDIF
-             ENDDO
-             DO  k = nzb, nzt
-                lad_w(k,j,i) = 0.5_wp * ( lad_s(k+1,j,i) + lad_s(k,j,i) )
-             ENDDO
-          ENDDO
-       ENDDO
-
-       lad_w(pch_index,:,:) = 0.0_wp
-       lad_w(nzt+1,:,:)     = lad_w(nzt,:,:)
-
-       CALL exchange_horiz( lad_u, nbgp )
-       CALL exchange_horiz( lad_v, nbgp )
-       CALL exchange_horiz( lad_w, nbgp )
-
-!
-!--    Initialisation of the canopy heat source distribution
-       IF ( cthf /= 0.0_wp )  THEN
-!
-!--       Piecewise evaluation of the leaf area index by 
-!--       integration of the leaf area density
-          lai(:,:,:) = 0.0_wp
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                DO  k = pch_index-1, 0, -1
-                   lai(k,j,i) = lai(k+1,j,i) +                   &
-                                ( 0.5_wp * ( lad_w(k+1,j,i) +    &
-                                          lad_s(k+1,j,i) ) *     &
-                                  ( zw(k+1) - zu(k+1) ) )  +     &
-                                ( 0.5_wp * ( lad_w(k,j,i)   +    &
-                                          lad_s(k+1,j,i) ) *     &
-                                  ( zu(k+1) - zw(k) ) )
-                ENDDO
-             ENDDO
-          ENDDO
-
-!
-!--       Evaluation of the upward kinematic vertical heat flux within the 
-!--       canopy
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                DO  k = 0, pch_index
-                   canopy_heat_flux(k,j,i) = cthf *                    &
-                                             exp( -0.6_wp * lai(k,j,i) )
-                ENDDO
-             ENDDO
-          ENDDO
-
-!
-!--       The near surface heat flux is derived from the heat flux 
-!--       distribution within the canopy
-          shf(:,:) = canopy_heat_flux(0,:,:)
-
-       ENDIF
-
-    ENDIF
+!-- If required, initialize quantities needed for the plant canopy model
+    IF ( plant_canopy )  CALL init_plant_canopy
 
 !
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 1483)
+++ palm/trunk/SOURCE/modules.f90	(revision 1484)
@@ -20,5 +20,7 @@
 ! Current revisions:
 ! ------------------
-! 
+! Changes due to new module structure of the plant canopy model:
+!   canopy-model related parameters/variables moved to module 
+!   plant_canopy_model_mod
 ! 
 ! Former revisions:
@@ -38,5 +40,5 @@
 ! 1429 2014-07-15 12:53:45Z knoop
 ! +ensemble_member_nr to prepare the random_generator for ensemble runs
-! 
+!
 ! 1382 2014-04-30 12:15:41Z boeske
 ! Renamed variables which store large scale forcing tendencies
@@ -294,5 +296,5 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE ::                                     &
           c_u_m, c_u_m_l, c_v_m, c_v_m_l, c_w_m, c_w_m_l, ddzu, ddzu_pres,     &
-          dd2zu, dzu, ddzw, dzw, hyp, inflow_damping_factor, lad, l_grid,      &
+          dd2zu, dzu, ddzw, dzw, hyp, inflow_damping_factor, l_grid,           &
           nc_1d, nr_1d, ptdf_x, ptdf_y, p_surf, pt_surf, pt_1d, pt_init,       &
           qsws_surf, q_1d, q_init, q_surf, qc_1d, qr_1d, rdf, rdf_sc,          & 
@@ -313,9 +315,9 @@
 
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::                                 &
-          canopy_heat_flux, cdc, d, de_dx, de_dy, de_dz, diss, diss_l_e,       &
+          d, de_dx, de_dy, de_dz, diss, diss_l_e,                              &
           diss_l_nr, diss_l_pt, diss_l_q, diss_l_qr, diss_l_sa, diss_l_u,      &
           diss_l_v, diss_l_w, flux_l_e, flux_l_nr, flux_l_pt, flux_l_q,        &
-          flux_l_qr, flux_l_sa, flux_l_u, flux_l_v, flux_l_w, kh, km, lad_s,   &
-          lad_u, lad_v, lad_w, lai, l_wall, p_loc, sec, sls, tend, tric,       &
+          flux_l_qr, flux_l_sa, flux_l_u, flux_l_v, flux_l_w, kh, km,          &
+          l_wall, p_loc, tend, tric,                                           &
           u_m_l, u_m_n, u_m_r, u_m_s, v_m_l, v_m_n, v_m_r, v_m_s, w_m_l,       &
           w_m_n, w_m_r, w_m_s
@@ -533,5 +535,4 @@
                              bc_sa_t = 'neumann', &
                              bc_uv_b = 'dirichlet', bc_uv_t = 'dirichlet', &
-                             canopy_mode = 'block', &
                              cloud_scheme = 'seifert_beheng', &
                              coupling_mode = 'uncoupled', &
@@ -586,5 +587,5 @@
                      nr_timesteps_this_run = 0, &
                      nsor = 20, nsor_ini = 100, n_sor, normalizing_region = 0, &
-                     nz_do3d = -9999, pch_index = 0, prt_time_count = 0, &
+                     nz_do3d = -9999, prt_time_count = 0, &
                      recycling_plane, runnr = 0, &
                      skip_do_avs = 0, subdomain_size, terminate_coupled = 0, &
@@ -596,5 +597,4 @@
                      do3d_no(0:1) = 0, do3d_time_count(0:1), &
                      domask_no(max_masks,0:1) = 0, domask_time_count(max_masks,0:1),&
-                     lad_vertical_gradient_level_ind(10) = -9999, &
                      mask_size(max_masks,3) = -1, mask_size_l(max_masks,3) = -1, &
                      mask_start_l(max_masks,3) = -1, &
@@ -652,5 +652,5 @@
                 outflow_l = .FALSE., outflow_n = .FALSE., outflow_r = .FALSE., &
                 outflow_s = .FALSE., passive_scalar = .FALSE., &
-                plant_canopy = .FALSE., prandtl_layer = .TRUE., &
+                prandtl_layer = .TRUE., &
                 precipitation = .FALSE., &
                 radiation = .FALSE., random_heatflux = .FALSE., &
@@ -682,10 +682,10 @@
                  canyon_width_x = 9999999.9_wp, canyon_width_y = 9999999.9_wp, &
                  canyon_wall_left = 9999999.9_wp, canyon_wall_south = 9999999.9_wp, &
-                 cthf = 0.0_wp, cfl_factor = -1.0_wp, cos_alpha_surface, &
+                 cfl_factor = -1.0_wp, cos_alpha_surface, &
                  coupling_start_time = 0.0_wp, disturbance_amplitude = 0.25_wp, &
                  disturbance_energy_limit = 0.01_wp, &
                  disturbance_level_b = -9999999.9_wp, &
                  disturbance_level_t = -9999999.9_wp, &
-                 dp_level_b = 0.0_wp, drag_coefficient = 0.0_wp, &
+                 dp_level_b = 0.0_wp, &
                  dt = -1.0_wp, dt_averaging_input = 0.0_wp, &
                  dt_averaging_input_pr = 9999999.9_wp, dt_coupling = 9999999.9_wp, &
@@ -703,5 +703,4 @@
                  f = 0.0_wp, fs = 0.0_wp, g = 9.81_wp, inflow_damping_height = 9999999.9_wp, &
                  inflow_damping_width = 9999999.9_wp, kappa = 0.4_wp, km_constant = -1.0_wp,&
-                 lad_surface = 0.0_wp, leaf_surface_concentration = 0.0_wp, &
                  mask_scale_x = 1.0_wp, mask_scale_y = 1.0_wp, mask_scale_z = 1.0_wp, &
                  maximum_cpu_time_allowed = 0.0_wp,  &
@@ -719,5 +718,5 @@
                  restart_time = 9999999.9_wp, rho_reference, rho_surface, &
                  rif_max = 1.0_wp, rif_min = -5.0_wp, roughness_length = 0.1_wp, &
-                 sa_surface = 35.0_wp, scalar_exchange_coefficient = 0.0_wp, &
+                 sa_surface = 35.0_wp, &
                  simulated_time = 0.0_wp, simulated_time_at_begin, sin_alpha_surface, &
                  skip_time_data_output = 0.0_wp, skip_time_data_output_av = 9999999.9_wp,&
@@ -745,6 +744,5 @@
     REAL(wp) ::  do2d_xy_last_time(0:1) = -1.0_wp, do2d_xz_last_time(0:1) = -1.0_wp, &
                  do2d_yz_last_time(0:1) = -1.0_wp, dpdxy(1:2) = 0.0_wp, &
-                 dt_domask(max_masks) = 9999999.9_wp, lad_vertical_gradient(10) = 0.0_wp,&
-                 lad_vertical_gradient_level(10) = -9999999.9_wp, &
+                 dt_domask(max_masks) = 9999999.9_wp, &
                  mask_scale(3), &
                  pt_vertical_gradient(10) = 0.0_wp, &
Index: palm/trunk/SOURCE/package_parin.f90
===================================================================
--- palm/trunk/SOURCE/package_parin.f90	(revision 1483)
+++ palm/trunk/SOURCE/package_parin.f90	(revision 1484)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-! 
+! Changes due to new module structure of the plant canopy model:
+!   module plant_canopy_model_mod added,
+!   new package/namelist canopy_par added, i.e. the canopy model is no longer 
+!   steered over the inipar-namelist,
+!   drag_coefficient, leaf_surface_concentration and scalar_exchange_coefficient
+!   renamed to canopy_drag_coeff, leaf_surface_conc and leaf_scalar_exch_coeff.
+! Changed statement tags in CONTINUE-statement
 ! 
 ! Former revisions:
@@ -103,4 +109,11 @@
                write_particle_statistics
 
+    USE plant_canopy_model_mod,                                                &
+        ONLY:  alpha_lad, beta_lad, calc_beta_lad_profile, canopy_drag_coeff,  &
+               canopy_mode, cthf, lad_surface,                                 &
+               lad_vertical_gradient, lad_vertical_gradient_level, lai_beta,   &
+               leaf_scalar_exch_coeff, leaf_surface_conc, pch_index,           &
+               plant_canopy
+
     USE spectrum,                                                              &
         ONLY:  comp_spectra_level, data_output_sp, plot_spectra_level,         &
@@ -110,4 +123,13 @@
 
     CHARACTER (LEN=80) ::  line  !:
+
+    NAMELIST /canopy_par/         alpha_lad, beta_lad, canopy_drag_coeff,      &
+                                  canopy_mode, cthf,                           &
+                                  lad_surface,                                 & 
+                                  lad_vertical_gradient,                       &
+                                  lad_vertical_gradient_level,                 &
+                                  lai_beta,                                    &
+                                  leaf_scalar_exch_coeff,                      &
+                                  leaf_surface_conc, pch_index
 
     NAMELIST /dvrp_graphics_par/  clip_dvrp_l, clip_dvrp_n, clip_dvrp_r,       &
@@ -159,9 +181,35 @@
     line = ' '
 
+!
+!-- Try to find canopy package
+    REWIND ( 11 )
+    line = ' '
+    DO   WHILE ( INDEX( line, '&canopy_par' ) == 0 )
+       READ ( 11, '(A)', END=10 )  line
+    ENDDO
+    BACKSPACE ( 11 )
+
+!
+!-- Read user-defined namelist
+    READ ( 11, canopy_par )
+
+!
+!-- Set flag that indicates that canopy model is switched on
+    plant_canopy = .TRUE.
+
+!
+!-- Set flag that indicates that the lad-profile shall be calculated by using
+!-- a beta probability density function
+    IF ( alpha_lad /= 9999999.9_wp  .AND.  beta_lad /= 9999999.9_wp )          &
+       calc_beta_lad_profile = .TRUE.
+
+ 10 CONTINUE
+
+
 #if defined( __dvrp_graphics )
     REWIND ( 11 )
     line = ' '
     DO   WHILE ( INDEX( line, '&dvrp_graphics_par' ) == 0 )
-       READ ( 11, '(A)', END=10 )  line
+       READ ( 11, '(A)', END=20 )  line
     ENDDO
     BACKSPACE ( 11 )
@@ -171,5 +219,5 @@
     READ ( 11, dvrp_graphics_par )
 
- 10 CONTINUE
+ 20 CONTINUE
 #endif
 
@@ -179,5 +227,5 @@
     line = ' '
     DO   WHILE ( INDEX( line, '&particles_par' ) == 0 )
-       READ ( 11, '(A)', END=20 )  line
+       READ ( 11, '(A)', END=30 )  line
     ENDDO
     BACKSPACE ( 11 )
@@ -191,5 +239,5 @@
     particle_advection = .TRUE.
 
- 20 CONTINUE
+ 30 CONTINUE
 
 
@@ -198,5 +246,5 @@
     line = ' '
     DO   WHILE ( INDEX( line, '&spectra_par' ) == 0 )
-       READ ( 11, '(A)', END=30 )  line
+       READ ( 11, '(A)', END=40 )  line
     ENDDO
     BACKSPACE ( 11 )
@@ -211,5 +259,5 @@
     IF ( dt_dosp == 9999999.9_wp )  dt_dosp = dt_data_output
 
- 30 CONTINUE
+ 40 CONTINUE
 #endif
 
